Debian 10, Ubuntu 18.04 a DSigner

Potvrdzujem, že návod od [andrewsh] funguje aj na ubuntu 19.10

2 Likes

@andrewsh vďaka za návod.
Linux Mint 19.3, Icedtea sice mám nainštalovaný verzia 1.8.0, JDK nemám.
Copy & Paste obsah súboru deployment.properties ktorý si tu pripojil.
A podpisovanie funguje na portáli finančnej správy aj na službách živnostenského registra cez Firefox aj Chrome. :ok_hand: :ok_hand: :+1: :+1:

Vďaka za tento návod, niekedy na začiatku roka mi prestalo fungovať podpisovanie s podivnou chybou, resp. chyba niekedy sa ani nezobrazí. Toto to vyriešilo.

Moje dočasné riešenie bolo stiahnutie softvéru podpisuj.sk, ktorý funguje vždy aj na Linuxe. Zatiaľ sa nikto z byrokratov nesťažoval.

Babráci programujúci slovensko.sk by mali vrátiť svoje občianske preukazy a byť pod dozorom, kým nevyriešia technologickú diskrimináciu ľudí na Linuxe.

Chcel by som poprosiť, pokiaľ je to možné, ako ste mal nakonfigurované deployment.properties pre openjdk-11 . S openjdk-8 a icedtea-netx mi podpisovanie funguje úplne korektne, ale pre openjdk-11 spadne s neznámou chybnou už pri loade podpisového komponentu. Všimol som si, že JFX už nie je súčasťou jdk-11, tak som doinštaloval OpenJFX, ale nepomohlo. Preto vyzvedám, v akej konfigurácii sa to podarilo Vám. Zrejme ešte nemám niečo doinštalované, čo bolo v openjdk-8 a oputilo to openjdk-11. Nejaké chyby som tam mal aj s netty, ale aj to som tiež doinštaloval. Ale čo som o tej chybe s netty zistil niekde na webe, tak že má problém s sun.nio balíkom a je potrebné ho nejako inak v kóde volať. Ja som sa však v logu stratil.
Keby sa mi podarilo zistiť príčinu prečo to nefunguje, tak by bolo možné nastaviť konfigurácie pre rôzne verzie javy, čo by bolo ideálne. A kľudne by to mohlo ísť do nejakej dokumentácie, aby s tým bežný používatelia na linux-e nemuseli experimentovať. Mali by v dokumentáci: pre openjdk-8 nainštalovať balíky závislostí tieto a tieto a deployment.properties nastaviť takto a takto. Pre openjdk-11 takto a pre openjdk-15 takto. Inak, keď mi to nefungovalo ešte asi rok späť, tak aj mne odporučili zo slovensko.sk Oracle jdk-1.8, namiesto openjdk-8. Zrejme sa nikto neunúval pozrieť do logov, čo som im vtedy poslal.
Keby na tom záležalo, tastujem to na Kubuntu 20.10, openjdk-8, icedtea-netx a to funguje, a Kubuntu 20.10, openjdk11, icedtea-netx a to nefunguje. Ani na 20.04 LTS . A pod nefunguje myslím “ja som to nevedel spojazdniť”.

Chcel by som poprosiť, pokiaľ je to možné, ako ste mal nakonfigurované deployment.properties pre openjdk-11

Ako som písal, môže byť ľubovolná verzia IcedTea, ale OpenJDK musí byť 8; OpenJDK 11 má zmeny, ktoré Ditec odmieta podporovať.

Pre istotu: OpenJDK 8 Ubuntu 20.10 aj 21.04 stále majú:

$ apt policy openjdk-8-jre
openjdk-8-jre:
  Installed: 8u282-b07-0ubuntu1
  Candidate: 8u282-b07-0ubuntu1
  Version table:
 *** 8u282-b07-0ubuntu1 500
        500 http://at.archive.ubuntu.com/ubuntu hirsute/universe amd64 Packages
        100 /var/lib/dpkg/status
     8u275-b01-0ubuntu1~20.10 500
        500 http://at.archive.ubuntu.com/ubuntu groovy-updates/universe amd64 Packages
        500 http://at.archive.ubuntu.com/ubuntu groovy-security/universe amd64 Packages
     8u272~b09-0ubuntu1 500
        500 http://at.archive.ubuntu.com/ubuntu groovy/universe amd64 Packages
1 Like

Áno s tým som OK. openjdk-8 mi ide korektne, aj to mám permanentne nastavené. Len v postoch vyššie som si všimol a nielen u Vás, že to ide aj na openjdk-11 a chcel som zistiť, ako sa Vám to podarilo. Preto som sa opýtal. A ďakujem sa predošlú odpoveď.

Len v postoch vyššie som si všimol a nielen u Vás, že to ide aj na openjdk-11 a chcel som zistiť, ako sa Vám to podarilo.

Mne sa to nepodarilo. Mám nainštalované OpenJDK 11 a 8 súčasne.

Keď som písal o „presne týchto verziách“, išlo o OpenJFX, nie OpenJDK/JRE. OpenJFX môže kľudne byť 11.*.

Takže namiesto tohto:

stačí:

sudo apt install openjfx
  1. Balík openjfx už má zavislosti na libopendjx-java, a ten má libopenjdx-jni; -source nie je potrebný;
  2. Presná verzia 8u161-b12-1ubuntu2 nie je potrebná, môže byť ľubovoľná.

Takto už je to OK. Z postu som nevedel vyvodiť, že inou verziou myslíte inú verziu openJFX, nakoľko v poste na ktorý ste odpovedal bolo spomínané práve OpenJDK. A aj pán Kupec v príspevku v 29.1.2020 písal, že mu funguje openjdk-11, tak som bol zaskočený, že mi to nejde. Ďakujem.

Tu ( OpenJDK Support - What You Need to Know? ) pisu, ze od 2019/01 je Java 8 EOL (z pohladu “free” verzie, nejaky ten komercny support od Oracle sa este zrejme obstarat da, ale to je myslim z pohladu bezneho obcana nonsens), t.j.: WTF? Cakaju, kym Java 8 dopadne ako Flash? V takom pripade si prosim bookmarkujme toto:

1 Like

od 2019/01 je Java 8 EOL

Presne toto som im písal, nič normálne mi na to neodpovedali.

3 Likes

No neviem ci si občania uvedomujú ale od apríla 2019 je aj Java 8 runtime spoplatnený, ak niekto po tomto dátume aktualizoval javu, pouziva D.Signer/Java, alebo cokolvek iné na Jave a nemá zakúpenú komerčnú licenciu od spoločnosti Oracle (čo je asi 25 USD /Rok) , tak v podstate porušuje zákon.
Portál Slovensko.sk by mal na tútu skoutočnost pri sťahovaní týchto toolov upozorniť, lebo bežný občan o tom nemá ani tušenie.

3 Likes

Ok alebo by sa mal s touto licencnou zalezitostou vysporiadat bud vyrobca podpisovacich komponent ktory ju pouziva, alebo stat. Obcan by do toho nemal byt zatahovany.

Radiť, že OpenJDK je štandard je OK… len keby slovenské eID bol štandard. Vtedy by na podpisovanie stačil LibreOffice.

1 Like

len keby slovenské eID bol štandard. Vtedy by na podpisovanie stačil LibreOffice.

To be fair, to sa dá, len LibreOffice nerobí podpisy presne podľa eIDAS, ak správne pamätám.

Sudiac podla toho, ze Nemci boli schpny do LibreOffice pridat podporu pre OpenPGP (vid Signed sealed & delivered ) tak aj toto povazujem za fixnutelne. Tot len kaby napr. povedzme mala cast nasich aktualnych nakladov na MS licenecie bola presmerovana tymto smerom … Alebo pockame, kym to za nas opat spravia Nemci.

Nuz, neviem ci a ako medzicasom vyriesili zmatocnu informaciu ohladom “… nelicencovana verzia …” ktoru sme debatili tu: Nova verzia eID pre Windows - #8 by hanecak . T.j. suhlas + aj preto je to u mna kategoria “wtf?”.

debian 10.8, doinstaloval som si openjfx (latest 11nieco) ale zial stale bojujem s chybou:

[AWT-EventQueue-2] ERROR sk.ditec.zep.dsigner.xades.plugins.xmlplugin.sdp.XmlVisualizer - Chyba pri zobrazeni vizualizace

[mkeseg][ITW-JAVAWS][ERROR_DEBUG][Fri Feb 12 00:19:45 CET 2021][net.sourceforge.jnlp.runtime.JNLPClassLoader.loadClass(JNLPClassLoader.java:1601)] NETX Thread# 1b26ebdb, name AWT-EventQueue-2: java.lang.ClassNotFoundException: javafx.scene.web.WebView at net.sourceforge.jnlp.runtime.JNLPClassLoader.loadClassExt(JNLPClassLoader.java:1798) at net.sourceforge.jnlp.runtime.JNLPClassLoader.loadClass(JNLPClassLoader.java:1598) at java.lang.Class.forName0(Native Method) at java.lang.Class.forName(Class.java:264) at sk.ditec.zep.dsigner.xades.plugins.xmlplugin.sdp.WebBrowser.isJavaFx(WebBrowser.java:126) at sk.ditec.zep.dsigner.xades.plugins.xmlplugin.sdp.WebBrowser.(WebBrowser.java:41) at sk.ditec.zep.dsigner.xades.plugins.xmlplugin.sdp.XmlVisualizer.createWebBrowser(XmlVisualizer.java:89) at sk.ditec.zep.dsigner.xades.plugins.xmlplugin.sdp.XmlVisualizer.createContent(XmlVisualizer.java:218) at sk.ditec.zep.dsigner.xades.plugins.xmlplugin.sdp.XmlVisualizer$1.run(XmlVisualizer.java:68) at sk.ditec.zep.dsigner.xades.utils.DSignerUtils.swingInvokeAndWait(DSignerUtils.java:360) at sk.ditec.zep.dsigner.xades.plugins.xmlplugin.sdp.XmlVisualizer.(XmlVisualizer.java:65) at sk.ditec.zep.dsigner.xades.bp.plugins.xmlplugin.XmlBpPluginInternal.getVisualizer(XmlBpPluginInternal.java:60) at sk.ditec.zep.dsigner.xades.sic.DSignerWindowManager.appendVisualizer(DSignerWindowManager.java:194) at sk.ditec.zep.dsigner.xades.sic.DSignerWindowManager.access$3(DSignerWindowManager.java:191) at sk.ditec.zep.dsigner.xades.sic.DSignerWindowManager$1$1.run(DSignerWindowManager.java:171) at java.awt.event.InvocationEvent.dispatch(InvocationEvent.java:311) at java.awt.EventQueue.dispatchEventImpl(EventQueue.java:758) at java.awt.EventQueue.access$500(EventQueue.java:97) at java.awt.EventQueue$3.run(EventQueue.java:709) at java.awt.EventQueue$3.run(EventQueue.java:703) at java.security.AccessController.doPrivileged(Native Method) at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(ProtectionDomain.java:74) at java.awt.EventQueue.dispatchEvent(EventQueue.java:728) at java.awt.EventDispatchThread.pumpOneEventForFilters(EventDispatchThread.java:205) at java.awt.EventDispatchThread.pumpEventsForFilter(EventDispatchThread.java:116) at java.awt.EventDispatchThread.pumpEventsForHierarchy(EventDispatchThread.java:105) at java.awt.EventDispatchThread.pumpEvents(EventDispatchThread.java:101) at java.awt.EventDispatchThread.pumpEvents(EventDispatchThread.java:93) at java.awt.EventDispatchThread.run(EventDispatchThread.java:82)
[mkeseg][ITW-JAVAWS][MESSAGE_DEBUG][Fri Feb 12 00:19:45 CET 2021][net.sourceforge.jnlp.runtime.JNLPProxySelector.select(JNLPProxySelector.java:212)] NETX Thread# 1b26ebdb, name AWT-EventQueue-2: Selected proxies: [DIRECT]

nevies co skontrolovat ? Teda dufam ze to je spravna chyba. Log viem poslat

Neviem ci ma vyznam ze hned za tym je odkaz na

https://www.slovensko.sk/static/zep/java_apps/javafx/scene/web/WebView.class

co je 404ka

inac je to dokument na vyzvy BSK a zial workflow nepusti ze by som stiahol dokument, podpisal a tak submitol.
Prilohy ale podpisem uplne v pohode, lebo tie su pdf alebo png

Tu je ono.

Mne openjfx podľa závislostí nainštaluje aj libopenjfx-java, súčasťou ktorého je súbor /usr/share/java/javafx-web-11.jar. Keď sa pozriem dnu, je tam javafx/scene/web/WebView.class. Podľa mňa to bude tým, že používa to format Java class 54, ktorý je od Java 10. Pozrel som sa changelog a vyzerá, že asi to bolo tak od prvej 11-ky.

Tak potom asi naozaj vizualizácia bude potrebovať len verziu 8.x. Neviem prečo mi to ide — možno tým, že nepoužívam vizualizáciu?

tento subor mam aj aj. Dokonca som dal do parametrov deployment.properties

–module-path=/usr/share/java --add-modules javafx.controls,javafx.fxml,javafx.graphics

ale error tam je. Ja bezne podpisujem danove, ale toto je vyzva na BSK, attachmenty popopdpisujem ale samotny formular ani za nic.

Takze vravis skusit nainstalovat stare openjfx, skusim.

Neviete niekto kde vyskusat openjfx s dLaucherom? Ja som nakoniec vyriesil problem na windows boxe, ale chcel by som doinstalovat veci aj ku sebe, len formular na BSK uz nie je pristupny.